	subroutine pfxtext( xc, yc, angle, size, font, ptext, stext )
c
c Draw an extended character-set string.
c
c ( Inputs )
c  xc --- Center x coordinate of the first character.
c  yc --- Center y coordinate of the first character.
c  angle -- angle in degree.
c  size --- Character size in degree.
c  font --- 1 for simplex, 2 for duplex
c  ptext --- Primary text character string.
c  stext --- Secondary text character string.
c
	implicit	none
c
	real*4		xc
	real*4		yc
	real*4		angle
	real*4		size
	integer*4	font
	character*(*)	ptext
	character*(*)	stext
c
c Local variables.
c
	real*4		ratio
	real*4		x
	real*4		y
	integer*4	bbit
	integer*4	nchar
	integer*4	status
c
	common/ UGA013 / simplex_ptr
	integer*2	simplex_ptr( 500 )
	common/ UGA014 / duplex_ptr
	integer*2	duplex_ptr( 500 )
	common/ UGA015 / ubc_ptr
	integer*2	ubc_ptr( 500 )
c
	nchar = len( ptext )
	if( len( stext ) .ne. nchar ) then
	  call pfclos( ' ' )
	  print *, ' %ERROR in PFXTEXT: lengthes of the 1mry and 2dry text',
	1	' are different.'
	  call exit
	endif
c
	call pfratio( ratio )
c
c Open the font data.
c
	if( font .eq. 3 ) then
	  call uge001( 0, 1, 1, 1, xc, yc, size, angle, ratio, 
	1					ubc_ptr, status )
	else if( font .eq. 2 ) then
	  call uge001( 0, 1, 1, 1, xc, yc, size, angle, ratio, 
	1					duplex_ptr, status )
	else
	  call uge001( 0, 1, 1, 1, xc, yc, size, angle, ratio, 
	1					simplex_ptr, status )
	endif
	if( status .eq. 1 ) then
	  call pfclos( ' ' )
	  print *, ' %ERROR in PFXTEXT: Character table not found.'
	  call exit
	endif
c
	call pfwidth( 1, size )
c
c Now loop over the characters in the string. Next calls of uge002 will
c convert the character to actual strokes.
c
100	continue
	  if( font .eq. 3 ) then
	    call uge002( ptext, stext, nchar, ubc_ptr, bbit, 
	1					x, y, status )
	  else if( font .eq. 2 ) then
	    call uge002( ptext, stext, nchar, duplex_ptr, bbit, 
	1					x, y, status )
	  else
	    call uge002( ptext, stext, nchar, simplex_ptr, bbit, 
	1					x, y, status )
	  endif
c
	  if( bbit .lt. 0 ) then
c end of the string.
	    go to 500
	  else if( bbit .eq. 0 ) then
c Dark vector.
	    call pfvect( x, y, 0 )
	  else
c Visible vector.
	    call pfvect( x, y, 1 )
	  endif
	go to 100
500	continue
	call pfwidth( 0, size )
	return
	end
