#include	"plot.h"
#include	<stdio.h>

/*
	Create X window.
*/

plcreX( xpos, ypos, xsize, ysize, title, pixmap )
int	xpos;		/* Window position X */
int	ypos;		/* Window position Y */
int	xsize;		/* Window size X */
int	ysize;		/* Window size Y */
char	*title;		/* Window's title */
int	pixmap;		/* 1 for create Pixel map, 0 for no create */
{
	int		screen;
	int		border_width;
	XGCValues	values;
	XEvent		event;
	unsigned long	mask;

	if( getenv( "DISPLAY" ) == NULL )
	{
		fprintf( stderr, "Please setenv DISPLAY.\n" );
		exit(0);
	}
	XDISPLAY = XOpenDisplay( "" );
	if( !XDISPLAY ) exit(0);	/* Failed to connect with the server */
	screen = DefaultScreen( XDISPLAY );
	border_width = 4;
	XWINDOW = XCreateSimpleWindow( XDISPLAY, 
				     RootWindow( XDISPLAY, screen ),
				     xpos, ypos, xsize, ysize, border_width,
				     WhitePixel( XDISPLAY, screen ),
				     BlackPixel( XDISPLAY, screen ) );
	XSelectInput( XDISPLAY, XWINDOW, ExposureMask );
	XChangeProperty( XDISPLAY, XWINDOW,
				XA_WM_NAME, XA_STRING, 8,
				PropModeReplace, 
				title,
				strlen( title ) );
	XMapWindow( XDISPLAY, XWINDOW );

	mask = GCLineWidth | GCForeground;
	values.line_width = 1;
	values.foreground = WhitePixel( XDISPLAY, screen );
	XGC = XCreateGC( XDISPLAY, XWINDOW, mask, &values );
	CMAP = DefaultColormap( XDISPLAY, screen );
	if( pixmap ) {
	  XPIXMAP = XCreatePixmap( XDISPLAY, XWINDOW, xsize, ysize, 
				DefaultDepth( XDISPLAY, screen ) );
	  PGC = XCreateGC( XDISPLAY, XPIXMAP, mask, &values );
	  XSetForeground( XDISPLAY, PGC, BlackPixel( XDISPLAY, screen ) );
	  XFillRectangle( XDISPLAY, XPIXMAP, PGC, 0, 0, xsize, ysize );
	  XSetForeground( XDISPLAY, PGC, WhitePixel( XDISPLAY, screen ) );
	}
	XFlush( XDISPLAY );
}
