#include	<stdio.h>
#include	"plot.h"

extern void simplex_();
extern void duplex_();
extern void ubcfont_();
#define TITLE_LEN 80

plopen( device ) /* Open a display device. */

char	*device ; /* "X:title" format is used to specify title */
{
	FILE	*fp;
	char	ldevice[9];
	char	title[TITLE_LEN];
	char	gdevice[9];
	int	i;
	int	colon;
	int	title_len;
	XEvent	event;

/*
 Dummy call of SIMPLEX, DUPLEX and UBCFONT.
*/
	simplex_();
	duplex_();
	ubcfont_();

	RESCALE = FALSE;
	VIDEO = FALSE;

	if( SAVEFILE )
	{
		plscrnms( 4040, 2780 ); /* Screen dot size for save-on-file. */
	}
/*
 Get device type.
*/
	colon = 0;
	for( i = 1; i < strlen( device ); i++ )
	{
		if( device[i] == ':' )
		{
			colon = i;
			break;
		}
	}

	if( colon )
	{
		strncpy( ldevice, device, colon );
		ldevice[colon] = 0;
		title_len = strlen( device ) - colon - 1;
		if( title_len > TITLE_LEN ) title_len = TITLE_LEN;
		strncpy( title, device+colon+1, title_len );
		title[title_len] = 0;
	} else 
	{
		strcpy( ldevice, device );
	}

	if( !strcmp( ldevice, "gdevice" ) ) /* Device type GDEVICE */
	{
		if( getenv( "GDEVICE" ) != 0 )
		{
			strcpy( gdevice, getenv( "GDEVICE" ) );
		}
		else
		{
			fprintf( stderr, "GDEVICE is not set. " );
			fprintf( stderr, "Please type a display device name: " );
			for(i=0;i<8;i++)	/* Get device name from terminal. */
			{
				if( ( gdevice[i] = getchar() ) == 0x0a ) break;
			}
			gdevice[i] = 0;
		}
	}
	else
	{
		strcpy( gdevice, ldevice );
	}

/* Now dispatch according to the device type. */

	if( !strcmp( gdevice, "necpc100" ) )
	{
		DEVICE_N = NECPC100;
		VIDEO = TRUE;
		ORIENTATION = LANDSCAPE;
		plscrnmx( 1, 719, 511 );	/* Screen dot size */
		putchar( GS );
		putchar( VT );
	}
	else if( !strcmp( gdevice, "tek4010" ) )
	{
		DEVICE_N = TEK4010;
		VIDEO = TRUE;
		ORIENTATION = LANDSCAPE;
		plscrnmx( 1, 1023, 780 );	/* Screen dot size */
		putchar( GS );
		putchar( US );
		putchar( ESC );
		putchar( FF );
		putchar( CAN );
	}
	else if( !strcmp( gdevice, "kermit" ) )
	{
		DEVICE_N = KERMIT;
		VIDEO = TRUE;
		ORIENTATION = LANDSCAPE;
		plscrnmx( 1, 1023, 780 );	/* Screen dot size */
		putchar( GS );
		putchar( US );
		putchar( ESC );
		putchar( FF );
		putchar( CAN );
	}
	else if( !strcmp( gdevice, "pc98vt" ) )
	{
		DEVICE_N = PC98VT;
		VIDEO = TRUE;
		ORIENTATION = LANDSCAPE;
		plscrnmx( 1, 639, 399 );	/* Screen dot size */
		putchar( ESC );
		putchar( 0x29 );
		putchar( 0x31 );
		putchar( SO );
		putchar( 0x61 );
		putchar( 0x63 );
	}
	else if( !strcmp( gdevice, "X" ) 
		|| !strcmp( gdevice, "XM" )
		|| !strcmp( gdevice, "XN" )
		|| !strcmp( gdevice, "XMN" ) ) { /* X-window */
		if( !strcmp( gdevice, "X" ) ) {
			DEVICE_N = X;
		} else if( !strcmp( gdevice, "XM" ) ) {
			DEVICE_N = XM;
		} else if( !strcmp( gdevice, "XN" ) ) {
			DEVICE_N = XN;
		} else if( !strcmp( gdevice, "XMN" ) ) {
			DEVICE_N = XMN;
		}
		if( !XWINDOW_OPEN )	 /* Create X window */
		{
			if( DEVICE_N == X || DEVICE_N == XM ) {
				plcreX( 100, 50, XWINDOW_XSIZE+1, 
				  XWINDOW_YSIZE+2, title, 1 ); /* Pixel map */
			} else {
				plcreX( 100, 50, XWINDOW_XSIZE+1, 
				  XWINDOW_YSIZE+2, title, 0 ); /* No pixel map */
			}
			XWINDOW_OPEN = TRUE;
			while( TRUE )	/* Wait for the window to be drawn. */
			{
				XNextEvent( XDISPLAY, &event );
				if( event.type == Expose ) break;
			}
		}
		VIDEO = TRUE;
		ORIENTATION = LANDSCAPE;
		plscrnmx( 1, XWINDOW_XSIZE, XWINDOW_YSIZE );	/* Screen size in pixel unit */
	}
	if( !strcmp( gdevice, "canonlbp" ) 
			||
		 !strcmp( gdevice, "lbp8" ) 
			||
		 SAVEFILE )
	{
		if( !strcmp( gdevice, "canonlbp" ) )
		{
			DEVICE_N = CANONLBP;
			plscrnmx( 1, 4040, 2780 );	/* Screen dot size */
			ORIENTATION = LANDSCAPE;
		}
		else if( !strcmp( gdevice, "lbp8" ) )
		{
			DEVICE_N = LBP8;
			plscrnmx( 1, 4040, 2780 );	/* Screen dot size */
			ORIENTATION = LANDSCAPE;
		}
		if(( fp = fopen( LBPFILE, "wa" )) == NULL )
		{
			fprintf( stderr, "Failed to open the file for CANONLBP\n" );
		}
		else
		{
			plsav_fp( SAVE, fp );
			putc(0x1b,fp); /* Reset. */
			putc('<',fp);
			
			putc(0x1b,fp); /* Change to full paint mode. */
			putc('[',fp);
			putc('2',fp);
			putc('&',fp);
			putc('z',fp);
			
			putc(0x1b,fp); /* Change to vector mode.*/
			putc('[',fp);
			putc('0',fp);
			putc('&',fp);
			putc('}',fp);

			putc(0x23,fp); /* Begin picture. */
			putc(0x1e,fp);

			putc(0x21,fp); /* Begin Scaling mode. */
			putc(0x30,fp);
			putc(0x21,fp);		/* Basic unit. */
			putc(0x32,fp);		/* Enlarge factor. */
			putc(0x1e,fp); /* End scaling mode. */

			putc(0x24,fp); /* Begin picture body. */
			putc(0x1e,fp); /* end of initial. */

			putc(0x46,fp); /* Begin line width specification. */
			putc(0x31,fp);
			putc(0x23,fp);
			putc(0x1e,fp); /* End line width specification. */

			CANONINI = 0;	/* Set CANON initial flag. */
		}
	}
	else if( !strcmp( gdevice, "psl" ) 
		|| !strcmp( gdevice, "pslm" ) 
		|| !strcmp( gdevice, "epsl" ) 
		|| !strcmp( gdevice, "epslm" ) ) { /* PostScript Landscape */
		if( !strcmp( gdevice, "pslm" ) 
		   || !strcmp( gdevice, "epslm" ) ) {
			DEVICE_N = POSTSCRIPTM;		/* pslm or epslm */
		} else {
			DEVICE_N = POSTSCRIPT;		/* psl or epsl */
		}
		ORIENTATION = LANDSCAPE;
		NSTROKE = 0;
		PS_PAGE = 1;
		PS_STATE = PS_INIT;
		plscrnmx( 1, 7500, 5300 );	/* Screen dot size in 0.1 pt unit */
		if(( fp = fopen( PSFILE, "wa" )) == NULL )
		{
			fprintf( stderr, "Failed to open the file for POSTSCRIPT\n" );
		}
		else
		{
			plsav_fp( SAVE, fp );
			if( !strcmp( gdevice, "epsl" ) 
			   || !strcmp( gdevice, "epslm" ) ) {
			  fprintf( fp, "%c!PS-Adobe-2.0 EPSF-2.0\n", '%' );
			} else {
			  fprintf( fp, "%c!PS-Adobe-2.0\n", '%' );
			}
			fprintf( fp, "%sCreator: topdrawer\n", "%%" );
			if( !strcmp( gdevice, "epsl" ) 
			   || !strcmp( gdevice, "epslm" ) ) {
			  fprintf( fp, "%sBoundingBox: %d %d %d %d\n", 
				  "%%", 31, 76, 564, 765 );
			}
			fprintf( fp, "%sEndComments\n", "%%" );
			fprintf( fp, "%sBeginProlog\n", "%%" );
			fprintf( fp, "%sBeginResource: lineabr\n", "%%" );
			fprintf( fp, "/m/moveto load def\n" );
			fprintf( fp, "/l/lineto load def\n" );
			fprintf( fp, "/Helvetica findfont\n" );
			fprintf( fp, "%sEndResource\n", "%%" );
			fprintf( fp, "%sEndProlog\n", "%%" );
			fprintf( fp, "%sBeginSetup\n", "%%" );
			fprintf( fp, "%sEndSetup\n", "%%" );
			fprintf( fp, "%sPage: %d %d\n", "%%", 
						PS_PAGE, PS_PAGE );
			fprintf( fp, "%sBeginPageSetup\n", "%%" );
			fprintf( fp, "%sEndPageSetup\n", "%%" );
			plpage( fp, PS_HEAD, LANDSCAPE );
			PS_STATE = PS_HEAD;
		}
	}
	else if( !strcmp( gdevice, "psp" ) 
		|| !strcmp( gdevice, "pspm" )
		|| !strcmp( gdevice, "epsp" )
		|| !strcmp( gdevice, "epspm" ) ) { /* PostScript Portrait */
		if( !strcmp( gdevice, "pspm" ) 
		   || !strcmp( gdevice, "epspm" ) ) {
			DEVICE_N = POSTSCRIPTM;
		} else { 
			DEVICE_N = POSTSCRIPT;
		}
		ORIENTATION = PORTRAIT;
		NSTROKE = 0;
		PS_PAGE = 1;
		PS_STATE = PS_INIT;
		plscrnmx( 2, 5300, 7500 );	/* Screen dot size in 0.1 pt unit */
		if(( fp = fopen( PSFILE, "wa" )) == NULL )
		{
			fprintf( stderr, "Failed to open the file for POSTSCRIPT\n" );
		}
		else
		{
			plsav_fp( SAVE, fp );
			if( !strcmp( gdevice, "epsp" ) 
			   || !strcmp( gdevice, "epspm" ) ) {
			  fprintf( fp, "%c!PS-Adobe-2.0 EPSF-2.0\n", '%' );
			} else {
			  fprintf( fp, "%c!PS-Adobe-2.0\n", '%' );
			}
			fprintf( fp, "%sCreator: topdrawer\n", "%%" );
			if( !strcmp( gdevice, "epsp" ) 
			   || !strcmp( gdevice, "epspm" ) ) {
			  fprintf( fp, "%sBoundingBox: %d %d %d %d\n", 
				  "%%", 28, 212, 561, 624 );
			}
			fprintf( fp, "%sEndComments\n", "%%" );
			fprintf( fp, "%sBeginProlog\n", "%%" );
			fprintf( fp, "%sBeginResource: lineabr\n", "%%" );
			fprintf( fp, "/m/moveto load def\n" );
			fprintf( fp, "/l/lineto load def\n" );
			fprintf( fp, "%sEndResource\n", "%%" );
			fprintf( fp, "%sEndProlog\n", "%%" );
			fprintf( fp, "%sBeginSetup\n", "%%" );
			fprintf( fp, "%sEndSetup\n", "%%" );
			fprintf( fp, "%sPage: %d %d\n", "%%", 
						PS_PAGE, PS_PAGE );
			fprintf( fp, "%sBeginPageSetup\n", "%%" );
			fprintf( fp, "%sEndPageSetup\n", "%%" );
			plpage( fp, PS_HEAD, PORTRAIT );
			PS_STATE = PS_HEAD;
		}
	}
	else if( !VIDEO )
	{
		fprintf( stderr, "ERROR in PLOPEN: Device name error. %s\n", 
				gdevice );
		exit( 0 );
	}
	plscrn( 0.0, 0.0, 1.0, 1.0 );	/* Set default screen size. */
	plwdow( 0.0, 0.0, 1.0, 1.0 );	/* Set default window size. */
}
