/*
 12-Jun-96	Added XN and XMN		- Y.Teramoto
 09-Mar-95	Added GC for lines and texts.	- Y.Teramoto
 22-Dec-92	Added X-window parameters	- Y.Teramoto
 5-Feb-90	Added save-on-file option. - Y.Teramoto
 24-Dec-88	Added the new device KERMIT. - Y.Teramoto
*/

#include	<stdio.h>
#include	<strings.h>
#include	<X11/Xlib.h>
#include	<X11/Xutil.h>
#include	<X11/Xatom.h>

#define NECPC100	1	/* Device # for PC100 */
#define TEK4010		2
#define PC98VT		3
#define CANONLBP	4
#define LBP8		5
#define KERMIT		6
#define POSTSCRIPT	7
#define POSTSCRIPTM	8
#define X		9
#define XM		10
#define XN		11
#define XMN		12

#define TRUE		1
#define FALSE		0

#define SAVE		0
#define RESTORE		1

#define BEL		0x07	/* Controll characters */
#define BS		0x08
#define HT		0x09
#define LF		0x0a
#define VT		0x0b
#define FF		0x0c
#define CR		0x0d
#define SO		0x0e
#define SI		0x0f
#define CAN		0x18
#define SUB		0x1a
#define ESC		0x1b
#define FS		0x1c
#define GS		0x1d
#define RS		0x1e
#define US		0x1f

/*
  CANONLBP and LBP8 parameters.
*/

#define LBPFILE		"CANONLBP"
#define CANONMXV	8	/* Max number of points in a single cmd.*/
#define HIGH_BIT	0x40
#define LOW_BIT		0x20
#define SIGN_BIT	0x10
#define MID_SHIFT	4
#define HIGH_SHIFT	6
#define LOW_MASK	0x0f
#define MID_MASK	0x3f
#define HIGH_MASK	0x3f

/* PostScript */
#define PSFILE		"POSTSCRIPT"
#define SIZE_LINE_FAC	0.02
#define LANDSCAPE	1
#define PORTRAIT	2
#define	MXSTROKE	300
#define PS_INIT		0
#define PS_HEAD		1
#define	PS_BODY		2
#define PS_TAIL		3

/* X window stuff */

Display		*XDISPLAY;	/* X window DISPLAY struct. */
Window		XWINDOW;	/* X window WINDOW struct. */
GC		XGC;		/* X window Graphic Contents struct. */
Colormap	CMAP;		/* Default color map. */
Pixmap		XPIXMAP;	/* Pixmap */
GC		PGC;		/* Pixmap Graphic Contents struct. */

#define		XWINDOW_XSIZE	767	/* X window's X size in pixels. */
#define		XWINDOW_YSIZE	585	/* X window's Y size in pixels. */
static int	XWINDOW_OPEN = 0;	/* X window open status. */

/* General parameters. */

int	DEVICE_N; 	/* Device number. */
char	DEVICE[8];	/* Device name. */
int	DSP_X_W;	/* Display screen X dot scale. */
int	DSP_Y_W;	/* Display screen Y dot scale. */
int	DSP_X_O;	/* Display screen X dot offset. */
int	DSP_Y_O;	/* Display screen Y dot offset. */
int	DSP_X;		/* Display screen X size. */
int	DSP_Y;		/* Display screen Y size. */
int	DSPS_X_W;	/* Display screen X dot scale for save-on-file. */
int	DSPS_Y_W;	/* Display screen Y dot scale for save-on-file. */
int	DSPS_X_O;	/* Display screen X dot offset for save-on-file. */
int	DSPS_Y_O;	/* Display screen Y dot offset for save-on-file. */
int	DSPS_X;		/* Display screen X size for save-on-file. */
int	DSPS_Y;		/* Display screen Y size for save-on-file. */
float	DSP_X_F;	/* Floating of DSP_X. */
float	DSP_Y_F;	/* Floating of DSP_Y. */
float	DSPS_X_F;	/* Floating of DSPS_X for save-on-file. */
float	DSPS_Y_F;	/* Floating of DSPS_Y for save-on-file. */
float	SCRN_X_L;	/* Screen X lower limit. */
float	SCRN_Y_L;	/* Screen Y lower limit. */
float	SCRN_X_H;	/* Screen X upper limit. */
float	SCRN_Y_H;	/* Screen Y upper limit. */
float	WDW_X_L;	/* Window X lower limit. */
float	WDW_Y_L;	/* Window Y lower limit. */
float	WDW_X_H;	/* Window X upper limit. */
float	WDW_Y_H;	/* Window Y upper limit. */
float	AX;
float	AY;
float	BX;
float	BY;
float	AXS;
float	AYS;
float	BXS;
float	BYS;

int	RESCALE;		/* Rescale flag. */
int	CANONINI;		/* Canon initial flag. */
int	SAVEFILE;		/* Save-on-file flag. */
int	VIDEO;			/* TRUE for video displays. */
int	ORIENTATION;		/* LANDSCAPE, UPSIDEDOWN or PORTRAIT */
int	NSTROKE;		/* # of lines output after stroke in PS */
int	PS_PAGE;		/* Page number for PS */
int	PS_STATE;		/* 1=header out, 2=body out, 3=tailer out */
