#include	"plot.h"

/*
	18-Apr-92, A bug was found and fixed. Y.Teramoto.
*/
plscal( mode, x1, y1, x2, y2, x1p, y1p, x2p, y2p )

int	mode;	/* 0 for regular, 1 for save-on-file plot. */
float	x1;	/* Input coordinate in ( 0.0 - 1.0 ) scale. */
float	y1;
float	x2;
float	y2;
int	*x1p;	/* Output coordinate in device scale. */
int	*y1p;
int	*x2p;
int	*y2p;
{ 
	float	x1t;
	float	x2t;
	float	y1t;
	float	y2t;
	float	dsp_x_f;
	float	dsp_y_f;
	float	a;
	float	b;
	float	xmin;
	float	xmax;
	float	ymin;
	float	ymax;
	float	x_ymin;
	float	x_ymax;
	float	y_xmin;
	float	y_xmax;
	float	sign;

	{
		if( mode == 0 )	/* Regular plot mode. */
		{
			plcvdv( x1, y1, &x1t, &y1t ); /* Convert to screen space. */
			plcvdv( x2, y2, &x2t, &y2t );
			dsp_x_f = DSP_X_F;
			dsp_y_f = DSP_Y_F;
		}
		else		/* Save-on-file mode. */
		{
			plcvdvs( x1, y1, &x1t, &y1t ); /* Convert to screen space. */
			plcvdvs( x2, y2, &x2t, &y2t );
			dsp_x_f = DSPS_X_F;
			dsp_y_f = DSPS_Y_F;
		}

		if( mode == 0 )	/* Regular plot. */
		{
			xmin = DSP_X_O + DSP_X_W * SCRN_X_L;
			xmax = DSP_X_O + DSP_X_W * SCRN_X_H;
			ymin = DSP_Y_O + DSP_Y_W * SCRN_Y_L;
			ymax = DSP_Y_O + DSP_Y_W * SCRN_Y_H;
		}
		else {		/* save-on-file plot. */
			xmin = DSPS_X_O + DSPS_X_W * SCRN_X_L;
			xmax = DSPS_X_O + DSPS_X_W * SCRN_X_H;
			ymin = DSPS_Y_O + DSPS_Y_W * SCRN_Y_L;
			ymax = DSPS_Y_O + DSPS_Y_W * SCRN_Y_H;
		}

		if( x1t < xmin && x2t < xmin ) /* Reject the outside case. */
			return( FALSE );
		if( x1t > xmax && x2t > xmax )
			return( FALSE );
		if( y1t < ymin && y2t < ymin )
			return( FALSE );
		if( y1t > ymax && y2t > ymax )
			return( FALSE );

		if( x1t + 0.5 >= x2t && x1t - 0.5 <= x2t ) 
		{				/* line  vertical */
			if( y1t < y2t )
			{
				y1t = plmax2( y1t, ymin );
				y2t = plmin2( y2t, ymax );
			}
			else 		/* y1t > y2t */
			{
				y1t = plmin2( y1t, ymax );
				y2t = plmax2( y2t, ymin );
			}
		}
		else	/* Line non-vertical case. */
		{
			/* Sort the points, so that x1t < x2t */

			plsort( 's', &x1t, &y1t, &x2t, &y2t );

			if( y1t - 0.5 < y2t && y1t + 0.5 > y2t )
			{		/* Horizontal case. */
				x1t = plmax2( x1t, xmin );
				x2t = plmin2( x2t, xmax );
			}
			else
			{
				a = ( y2t - y1t ) / ( x2t - x1t );
				b  = y1t - a * x1t;
				x_ymin = ( ymin - b ) / a;
				x_ymax = ( ymax - b ) / a;
				y_xmin = a * xmin + b;
				y_xmax = a * xmax + b;
				sign = y2t - y1t;

				if( y1t < y2t )
				{
					x1t = plmax3( x1t, xmin, x_ymin );
					x2t = plmin3( x2t, xmax, x_ymax );
					y1t = plmax3( y1t, ymin, y_xmin );
					y2t = plmin3( y2t, ymax, y_xmax );
				}
				else
				{
					x1t = plmax3( x1t, xmin, x_ymax );
					x2t = plmin3( x2t, xmax, x_ymin );
					y1t = plmin3( y1t, ymax, y_xmin );
					y2t = plmax3( y2t, ymin, y_xmax );
				}
/* Now check the condition. */
				if( x1t - 0.5 > x2t )
					return( FALSE );
				else
				{
					if( sign * ( y2t - y1t ) < 0.0 )
						return( FALSE );
				}
			}
			plsort( 'r', &x1t, &y1t, &x2t, &y2t );
		}
/* Reach this point, if the line is inside of the window. */
		*x1p = x1t;
		*y1p = y1t;
		*x2p = x2t;
		*y2p = y2t;
		return( TRUE );
	}
}
